{***************************************************************************}
{ CETools demo application                                                  }
{ for Delphi 4.0,5.0,6.0 & C++Builder 4.0,5.0                               }
{ version 1.0 - rel. August 2001                                            }
{                                                                           }
{ written by TMS Software                                                   }
{            copyright  2001                                               }
{            Email : info@tmssoftware.com                                   }
{            Web : http://www.tmssoftware.com                               }
{***************************************************************************}
unit UCEToolsDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, CETools, StdCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    CEAppointments1: TCEAppointments;
    CEDeviceInfo1: TCEDeviceInfo;
    InfoList: TListBox;
    Button1: TButton;
    Button2: TButton;
    CEFileOperations1: TCEFileOperations;
    Memo1: TMemo;
    Button3: TButton;
    Button4: TButton;
    DBList: TListBox;
    CEDatabase1: TCEDatabase;
    CEContacts1: TCEContacts;
    ContOpen: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Edit3: TEdit;
    Edit4: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    Label11: TLabel;
    Edit9: TEdit;
    Label12: TLabel;
    Edit10: TEdit;
    AppOpen: TButton;
    Button9: TButton;
    Button10: TButton;
    Label13: TLabel;
    Button5: TButton;
    DevName: TLabel;
    CERegistry1: TCERegistry;
    Label14: TLabel;
    DevBuild: TLabel;
    SoftList: TListBox;
    Label15: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ContOpenClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure AppOpenClick(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  InfoList.Items.Clear;

  if CEDeviceInfo1.Open then
  begin
    CEDeviceInfo1.GetSysInfo;

    InfoList.Items.Add('OS Version : ' +
      IntToStr(CEDeviceInfo1.OSMajorVersion) + ':' + IntToStr(CEDeviceInfo1.OSMinorVersion));

    InfoList.Items.Add('Processor type : ' + IntToStr(CEDeviceInfo1.ProcessorType));
    InfoList.Items.Add('Memoryload : ' + IntToStr(CEDeviceInfo1.MemoryLoad) + '%');
    InfoList.Items.Add('Available memory : ' + IntToStr(CEDeviceInfo1.AvailPhys));
    InfoList.Items.Add('Total memory : ' + IntToStr(CEDeviceInfo1.TotalPhys));

    InfoList.Items.Add('Battery life : ' + IntToStr(CEDeviceInfo1.BatteryLifePercent) + '%');
    InfoList.Items.Add('Backup battery life : ' + IntToStr(CEDeviceInfo1.BackupBatteryLifePercent) + '%');

    InfoList.Items.Add('Vert. resolution : ' + IntToStr(CEDeviceInfo1.GetDesktopDeviceCaps(VERTRES)));
    InfoList.Items.Add('Horz. resolution : ' + IntToStr(CEDeviceInfo1.GetDesktopDeviceCaps(HORZRES)));
    InfoList.Items.Add('Bits per pixel : ' + IntToStr(CEDeviceInfo1.GetDesktopDeviceCaps(BITSPIXEL)));

    if CEDeviceInfo1.GetSystemMetrics(SM_NETWORK) and 1 = 1 then
      InfoList.Items.Add('Network present : Yes')
    else
      InfoList.Items.Add('Network present : No');


  end
  else
  begin
    InfoList.Items.Add('No connected device found');
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   Memo1.Lines.SaveToFile(GetCurrentDir + '\memo.txt');

   CEFileOperations1.SourceFilename := GetCurrentDir + '\memo.txt';
   CEFileOperations1.TargetFilename := '\My Documents\memo.txt';

   CEFileOperations1.Operation := coCopyDesktopToCE;

   if CEFileOperations1.Execute then
     ShowMessage('Copied memo file on the CE device')
   else
     ShowMessage('Failed to copy memo file on the CE device');

end;

procedure TForm1.Button3Click(Sender: TObject);
begin

   CEFileOperations1.TargetFilename := GetCurrentDir + '\memo.txt';
   CEFileOperations1.SourceFilename := '\My Documents\memo.txt';

   CEFileOperations1.Operation := coCopyCEToDesktop;

   if CEFileOperations1.Execute then
   begin
     Memo1.Lines.LoadFromFile(GetCurrentDir + '\memo.txt');
     ShowMessage('Copied memo file from CE device to PC');
   end

   else
     ShowMessage('Failed to copy memo file from CE device');
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if CEDatabase1.Open then
  begin
     DBList.Items.Assign(CEDatabase1.DatabaseList);
  end
  else
    ShowMessage('No connected device found');
end;

procedure TForm1.ContOpenClick(Sender: TObject);
begin
   if ContOpen.Caption = 'Open' then
   begin

     if CEContacts1.Open then
     begin
       CEContacts1.Read;
       Edit1.Text := CEContacts1.Contact.PRENAME;
       Edit2.Text := CEContacts1.Contact.NAME;
       Edit3.Text := CEContacts1.Contact.TELHOME;
       Edit4.Text := CEContacts1.Contact.EMAIL1;
       Edit5.Text := CEContacts1.Contact.COMPANY;
       Edit6.Text := CEContacts1.Contact.DEPT;
     end;
     ContOpen.Caption := 'Close';
   end
   else
   begin
     CEContacts1.Close;
     ContOpen.Caption := 'Open';
     Edit1.Text := '';
     Edit2.Text := '';
     Edit3.Text := '';
     Edit4.Text := '';
     Edit5.Text := '';
     Edit6.Text := '';
   end;
end;



procedure TForm1.Button6Click(Sender: TObject);
begin
  if ContOpen.Caption = 'Open' then
    ContOpenClick(Sender)
  else
  begin
    CEContacts1.Prior;
    CEContacts1.Read;
    Edit1.Text := CEContacts1.Contact.PRENAME;
    Edit2.Text := CEContacts1.Contact.NAME;
    Edit3.Text := CEContacts1.Contact.TELHOME;
    Edit4.Text := CEContacts1.Contact.EMAIL1;
    Edit5.Text := CEContacts1.Contact.COMPANY;
    Edit6.Text := CEContacts1.Contact.DEPT;
  end;

end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  if ContOpen.Caption = 'Open' then
    ContOpenClick(Sender)
  else
  begin
    CEContacts1.Next;
    CEContacts1.Read;
    Edit1.Text := CEContacts1.Contact.PRENAME;
    Edit2.Text := CEContacts1.Contact.NAME;
    Edit3.Text := CEContacts1.Contact.TELHOME;
    Edit4.Text := CEContacts1.Contact.EMAIL1;
    Edit5.Text := CEContacts1.Contact.COMPANY;
    Edit6.Text := CEContacts1.Contact.DEPT;
  end;

end;

procedure TForm1.Button8Click(Sender: TObject);
var
  CC: TCEContactRecord;

begin
  FillChar(CC,SizeOf(CC),0);
  CC.PRENAME := Edit1.Text;
  CC.NAME := Edit2.Text;
  CC.TELHOME := Edit3.Text;
  CC.EMAIL1 := Edit4.Text;
  CC.COMPANY := Edit5.Text;
  CC.DEPT := Edit6.Text;
  CEContacts1.Contact := CC;
  CEContacts1.Write;
end;

procedure TForm1.AppOpenClick(Sender: TObject);
var
  EndDate: TDateTime;
begin
   if AppOpen.Caption = 'Open' then
   begin

     if CEAppointments1.Open then
     begin
       CEAppointments1.Read;
       Edit7.Text := CEAppointments1.Appointment.SUBJECT;
       Edit8.Text := CEAppointments1.Appointment.LOCATION;
       Edit9.Text := FormatDateTime('mmm, dd yyyy hh:nn',CEAppointments1.Appointment.Date);
       EndDate := CEAppointments1.Appointment.Date + CEAppointments1.Appointment.Len / (24*60);
       Edit10.Text := FormatDateTime('mmm, dd yyyy hh:nn',EndDate);
     end;
     AppOpen.Caption := 'Close';
   end
   else
   begin
     CEAppointments1.Close;
     AppOpen.Caption := 'Open';
     Edit7.Text := '';
     Edit8.Text := '';
     Edit9.Text := '';
     Edit10.Text := '';
   end;

end;

procedure TForm1.Button9Click(Sender: TObject);
var
  EndDate: TDateTime;

begin
  if AppOpen.Caption = 'Open' then
    AppOpenClick(Sender)
  else
  begin
    CEAppointments1.Prior;
    CEAppointments1.Read;
    Edit7.Text := CEAppointments1.Appointment.SUBJECT;
    Edit8.Text := CEAppointments1.Appointment.LOCATION;
    Edit9.Text := FormatDateTime('mmm, dd yyyy hh:nn',CEAppointments1.Appointment.Date);

    EndDate := CEAppointments1.Appointment.Date + CEAppointments1.Appointment.Len / (24*60);
    Edit10.Text := FormatDateTime('mmm, dd yyyy hh:nn',EndDate);

  end;

end;

procedure TForm1.Button10Click(Sender: TObject);
var
  EndDate: TDateTime;
begin
  if AppOpen.Caption = 'Open' then
    AppOpenClick(Sender)
  else
  begin
    CEAppointments1.Next;
    CEAppointments1.Read;
    Edit7.Text := CEAppointments1.Appointment.SUBJECT;
    Edit8.Text := CEAppointments1.Appointment.LOCATION;
    Edit9.Text := FormatDateTime('mmm, dd yyyy hh:nn',CEAppointments1.Appointment.Date);

    EndDate := CEAppointments1.Appointment.Date + CEAppointments1.Appointment.Len / (24*60);
    Edit10.Text := FormatDateTime('mmm, dd yyyy hh:nn',EndDate);

  end;

end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  CERegistry1.Open;
  CERegistry1.RootKey := HKEY_LOCAL_MACHINE;
  if CERegistry1.OpenKey('\Platform',True) then
  begin
    DevName.Caption := CERegistry1.ReadString('Name');
    DevBuild.Caption := IntToStr(CERegistry1.ReadInteger('Build'));
  end;
  CERegistry1.CloseKey;

  CERegistry1.RootKey := HKEY_CURRENT_USER;
  if CERegistry1.OpenKey('\Software\Microsoft',True) then
  begin
    CERegistry1.GetKeyNames(SoftList.Items);
  end;


  CERegistry1.Close;
end;

end.
